/* stats-page.c generated by valac 0.40.11, the Vala compiler
 * generated from stats-page.vala, do not modify */

/*
 * Copyright (c) 2017 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 *
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gom/gom.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <cairo.h>
#include <gdk/gdk.h>


#define POMODORO_TYPE_STATS_PAGE (pomodoro_stats_page_get_type ())
#define POMODORO_STATS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_STATS_PAGE, PomodoroStatsPage))
#define POMODORO_STATS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_STATS_PAGE, PomodoroStatsPageClass))
#define POMODORO_IS_STATS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_STATS_PAGE))
#define POMODORO_IS_STATS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_STATS_PAGE))
#define POMODORO_STATS_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_STATS_PAGE, PomodoroStatsPageClass))

typedef struct _PomodoroStatsPage PomodoroStatsPage;
typedef struct _PomodoroStatsPageClass PomodoroStatsPageClass;
typedef struct _PomodoroStatsPagePrivate PomodoroStatsPagePrivate;

#define POMODORO_STATS_PAGE_TYPE_DATA (pomodoro_stats_page_data_get_type ())
typedef struct _PomodoroStatsPageData PomodoroStatsPageData;
enum  {
	POMODORO_STATS_PAGE_0_PROPERTY,
	POMODORO_STATS_PAGE_DATE_PROPERTY,
	POMODORO_STATS_PAGE_DATE_END_PROPERTY,
	POMODORO_STATS_PAGE_TITLE_PROPERTY,
	POMODORO_STATS_PAGE_NUM_PROPERTIES
};
static GParamSpec* pomodoro_stats_page_properties[POMODORO_STATS_PAGE_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _pomodoro_stats_page_data_free0(var) ((var == NULL) ? NULL : (var = (pomodoro_stats_page_data_free (var), NULL)))
typedef struct _Block15Data Block15Data;
typedef struct _Block16Data Block16Data;

#define POMODORO_TYPE_AGGREGATED_ENTRY (pomodoro_aggregated_entry_get_type ())
#define POMODORO_AGGREGATED_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_AGGREGATED_ENTRY, PomodoroAggregatedEntry))
#define POMODORO_AGGREGATED_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_AGGREGATED_ENTRY, PomodoroAggregatedEntryClass))
#define POMODORO_IS_AGGREGATED_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_AGGREGATED_ENTRY))
#define POMODORO_IS_AGGREGATED_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_AGGREGATED_ENTRY))
#define POMODORO_AGGREGATED_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_AGGREGATED_ENTRY, PomodoroAggregatedEntryClass))

typedef struct _PomodoroAggregatedEntry PomodoroAggregatedEntry;
typedef struct _PomodoroAggregatedEntryClass PomodoroAggregatedEntryClass;
typedef struct _Block17Data Block17Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _PomodoroStatsPageFetchData PomodoroStatsPageFetchData;
typedef struct _PomodoroStatsPageGetReferenceValueData PomodoroStatsPageGetReferenceValueData;

struct _PomodoroStatsPage {
	GtkBox parent_instance;
	PomodoroStatsPagePrivate * priv;
	GtkSpinner* spinner;
	GtkDrawingArea* timeline_chart;
	GtkDrawingArea* totals_chart;
	GDateTime* _date;
	GomRepository* repository;
	guint64 reference_value;
	guint64 daily_reference_value;
};

struct _PomodoroStatsPageClass {
	GtkBoxClass parent_class;
	gchar* (*format_datetime) (PomodoroStatsPage* self, GDateTime* date);
	GDateTime* (*get_previous_date) (PomodoroStatsPage* self);
	GDateTime* (*get_next_date) (PomodoroStatsPage* self);
	void (*get_reference_value) (PomodoroStatsPage* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	guint64 (*get_reference_value_finish) (PomodoroStatsPage* self, GAsyncResult* _res_);
};

struct _PomodoroStatsPageData {
	gint64 pomodoro_elapsed;
	gint64 break_elapsed;
};

struct _PomodoroStatsPagePrivate {
	GDateTime* _date_end;
	gchar* _title;
	GHashTable* days;
};

typedef void (*PomodoroStatsPageDrawChartFunc) (cairo_t* context, gdouble* values, int values_length1, gdouble x, gdouble y, gdouble width, gdouble height, gpointer user_data);
struct _Block15Data {
	int _ref_count_;
	PomodoroStatsPage* self;
	PomodoroStatsPageData totals;
};

struct _Block16Data {
	int _ref_count_;
	PomodoroStatsPage* self;
	guint64 reference_value;
	gint64 daily_reference_value;
	gpointer _async_data_;
};

struct _Block17Data {
	int _ref_count_;
	Block16Data * _data16_;
	GomResourceGroup* group;
};

struct _PomodoroStatsPageFetchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	PomodoroStatsPage* self;
	Block16Data* _data16_;
	GHashTable* _tmp0_;
	gchar* date_start;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gchar* _tmp3_;
	gchar* date_end;
	GDateTime* _tmp4_;
	gchar* _tmp5_;
	GomFilter* filter;
	GValue _tmp6_;
	GomFilter* _tmp7_;
	GomFilter* _tmp8_;
	GValue _tmp9_;
	GomFilter* _tmp10_;
	GomFilter* _tmp11_;
	GomFilter* _tmp12_;
	GomFilter* _tmp13_;
	GomRepository* _tmp14_;
};

struct _PomodoroStatsPageGetReferenceValueData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	PomodoroStatsPage* self;
	guint64 result;
};


static gpointer pomodoro_stats_page_parent_class = NULL;
static GtkBuildableIface * pomodoro_stats_page_gtk_buildable_parent_iface = NULL;

GType pomodoro_stats_page_get_type (void) G_GNUC_CONST;
static GType pomodoro_stats_page_data_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static PomodoroStatsPageData* pomodoro_stats_page_data_dup (const PomodoroStatsPageData* self);
static void pomodoro_stats_page_data_free (PomodoroStatsPageData* self);
#define POMODORO_STATS_PAGE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), POMODORO_TYPE_STATS_PAGE, PomodoroStatsPagePrivate))
#define POMODORO_STATS_PAGE_GUIDES_OFFSET 5.0
#define POMODORO_STATS_PAGE_GUIDES_WIDTH 40.0
#define POMODORO_STATS_PAGE_CHART_PADDING 20.0
#define POMODORO_STATS_PAGE_LABEL_HEIGHT 20.0
#define POMODORO_STATS_PAGE_LABEL_OFFSET 10.0
#define POMODORO_STATS_PAGE_BAR_MAX_WIDTH 130.0
#define POMODORO_STATS_PAGE_BAR_RELATIVE_WIDTH 0.85
#define POMODORO_STATS_PAGE_BAR_BORDER_RADIUS 2.5
static gchar* pomodoro_stats_page_format_value (gint64 seconds);
static gchar* pomodoro_stats_page_format_day_of_month (GDateTime* date);
static gchar* pomodoro_stats_page_format_day_of_week (GDateTime* date);
static void pomodoro_stats_page_draw_label (cairo_t* context,
                                     const gchar* label,
                                     gdouble x,
                                     gdouble y,
                                     gdouble width,
                                     gdouble height);
static void pomodoro_stats_page_draw_guide_lines (cairo_t* context,
                                           gdouble reference_value,
                                           gdouble x,
                                           gdouble y,
                                           gdouble width,
                                           gdouble height,
                                           GdkRGBA* color);
static void pomodoro_stats_page_draw_bar (cairo_t* context,
                                   gdouble value,
                                   gdouble x,
                                   gdouble y,
                                   gdouble width,
                                   gdouble height);
static void pomodoro_stats_page_draw_bar_chart (cairo_t* context,
                                         gdouble* values,
                                         int values_length1,
                                         gdouble x,
                                         gdouble y,
                                         gdouble width,
                                         gdouble height);
static void pomodoro_stats_page_draw_line_chart (cairo_t* context,
                                          gdouble* values,
                                          int values_length1,
                                          gdouble x,
                                          gdouble y,
                                          gdouble width,
                                          gdouble height);
static gboolean pomodoro_stats_page_on_timeline_chart_draw (PomodoroStatsPage* self,
                                                     GtkWidget* widget,
                                                     cairo_t* context);
GDateTime* pomodoro_stats_page_get_date_end (PomodoroStatsPage* self);
GDateTime* pomodoro_stats_page_get_date (PomodoroStatsPage* self);
static gboolean _pomodoro_stats_page_on_timeline_chart_draw_gtk_widget_draw (GtkWidget* _sender,
                                                                      cairo_t* cr,
                                                                      gpointer self);
static gboolean pomodoro_stats_page_on_totals_chart_draw (PomodoroStatsPage* self,
                                                   GtkWidget* widget,
                                                   cairo_t* context);
static Block15Data* block15_data_ref (Block15Data* _data15_);
static void block15_data_unref (void * _userdata_);
static void __lambda9_ (Block15Data* _data15_,
                 const gchar* date_string,
                 PomodoroStatsPageData* data);
static void ___lambda9__gh_func (gconstpointer key,
                          gconstpointer value,
                          gpointer self);
static gboolean _pomodoro_stats_page_on_totals_chart_draw_gtk_widget_draw (GtkWidget* _sender,
                                                                    cairo_t* cr,
                                                                    gpointer self);
void pomodoro_stats_page_update (PomodoroStatsPage* self);
GDateTime* pomodoro_stats_page_get_next_date (PomodoroStatsPage* self);
void pomodoro_stats_page_set_date_end (PomodoroStatsPage* self,
                                       GDateTime* value);
void pomodoro_stats_page_fetch (PomodoroStatsPage* self,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
void pomodoro_stats_page_fetch_finish (PomodoroStatsPage* self,
                                       GAsyncResult* _res_);
static void __lambda12_ (PomodoroStatsPage* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda12__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void pomodoro_stats_page_fetch_data_free (gpointer _data);
static void pomodoro_stats_page_fetch_async_ready_wrapper (GObject *source_object,
                                                    GAsyncResult *res,
                                                    void *user_data);
static gboolean pomodoro_stats_page_fetch_co (PomodoroStatsPageFetchData* _data_);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
#define POMODORO_AGGREGATED_ENTRY_DATE_FORMAT "%Y-%m-%d"
GType pomodoro_aggregated_entry_get_type (void) G_GNUC_CONST;
void pomodoro_stats_page_get_reference_value (PomodoroStatsPage* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
guint64 pomodoro_stats_page_get_reference_value_finish (PomodoroStatsPage* self,
                                                        GAsyncResult* _res_);
static void pomodoro_stats_page_fetch_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_);
void pomodoro_aggregated_entry_get_baseline_daily_elapsed (GAsyncReadyCallback _callback_,
                                                           gpointer _user_data_);
gint64 pomodoro_aggregated_entry_get_baseline_daily_elapsed_finish (GAsyncResult* _res_);
static void __lambda10_ (Block16Data* _data16_,
                  GObject* obj,
                  GAsyncResult* res);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
static void ____lambda11_ (Block17Data* _data17_,
                    GObject* obj,
                    GAsyncResult* res);
const gchar* pomodoro_aggregated_entry_get_date_string (PomodoroAggregatedEntry* self);
const gchar* pomodoro_aggregated_entry_get_state_name (PomodoroAggregatedEntry* self);
gint64 pomodoro_aggregated_entry_get_elapsed (PomodoroAggregatedEntry* self);
static void _____lambda11__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static void ___lambda10__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
gchar* pomodoro_stats_page_format_datetime (PomodoroStatsPage* self,
                                            GDateTime* date);
static gchar* pomodoro_stats_page_real_format_datetime (PomodoroStatsPage* self,
                                                 GDateTime* date);
GDateTime* pomodoro_stats_page_get_previous_date (PomodoroStatsPage* self);
static GDateTime* pomodoro_stats_page_real_get_previous_date (PomodoroStatsPage* self);
static GDateTime* pomodoro_stats_page_real_get_next_date (PomodoroStatsPage* self);
static void pomodoro_stats_page_real_get_reference_value_data_free (gpointer _data);
static void pomodoro_stats_page_real_get_reference_value_async_ready_wrapper (GObject *source_object,
                                                                       GAsyncResult *res,
                                                                       void *user_data);
static void pomodoro_stats_page_real_get_reference_value (PomodoroStatsPage* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static gboolean pomodoro_stats_page_real_get_reference_value_co (PomodoroStatsPageGetReferenceValueData* _data_);
PomodoroStatsPage* pomodoro_stats_page_construct (GType object_type);
void pomodoro_stats_page_set_date (PomodoroStatsPage* self,
                                   GDateTime* value);
void pomodoro_stats_page_set_title (PomodoroStatsPage* self,
                                    const gchar* value);
const gchar* pomodoro_stats_page_get_title (PomodoroStatsPage* self);
static GObject * pomodoro_stats_page_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void _g_free0_ (gpointer var);
static void _pomodoro_stats_page_data_free0_ (gpointer var);
static void pomodoro_stats_page_finalize (GObject * obj);
static void _vala_pomodoro_stats_page_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_pomodoro_stats_page_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);


static gchar*
pomodoro_stats_page_format_value (gint64 seconds)
{
	gchar* result = NULL;
	gdouble part_hours = 0.0;
	gdouble _tmp1_;
	gdouble _tmp4_;
	gchar* _tmp5_;
	if (seconds < ((gint64) 3600)) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup_printf (_ ("%d m"), ((gint) seconds) / 60);
		result = _tmp0_;
		return result;
	}
	part_hours = round (seconds / 360.0);
	_tmp1_ = part_hours;
	if ((((gint) _tmp1_) % 10) == 0) {
		gdouble _tmp2_;
		gchar* _tmp3_;
		_tmp2_ = part_hours;
		_tmp3_ = g_strdup_printf (_ ("%.0f h"), _tmp2_ / 10.0);
		result = _tmp3_;
		return result;
	}
	_tmp4_ = part_hours;
	_tmp5_ = g_strdup_printf (_ ("%.1f h"), _tmp4_ / 10.0);
	result = _tmp5_;
	return result;
}


static gchar*
pomodoro_stats_page_format_day_of_month (GDateTime* date)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (date != NULL, NULL);
	_tmp0_ = g_strdup_printf ("%i", g_date_time_get_day_of_month (date));
	result = _tmp0_;
	return result;
}


static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}


static gchar*
pomodoro_stats_page_format_day_of_week (GDateTime* date)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	g_return_val_if_fail (date != NULL, NULL);
	_tmp0_ = g_date_time_format (date, "%A");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("%c", string_get (_tmp1_, (glong) 0));
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	result = _tmp3_;
	return result;
}


/**
         * Helper method to draw text centered inside a specified box
         */
static void
pomodoro_stats_page_draw_label (cairo_t* context,
                                const gchar* label,
                                gdouble x,
                                gdouble y,
                                gdouble width,
                                gdouble height)
{
	cairo_text_extents_t extents = {0};
	cairo_text_extents_t _tmp0_ = {0};
	cairo_text_extents_t _tmp1_;
	gdouble _tmp2_;
	cairo_text_extents_t _tmp3_;
	gdouble _tmp4_;
	cairo_text_extents_t _tmp5_;
	gdouble _tmp6_;
	cairo_text_extents_t _tmp7_;
	gdouble _tmp8_;
	g_return_if_fail (context != NULL);
	g_return_if_fail (label != NULL);
	cairo_text_extents (context, label, &_tmp0_);
	extents = _tmp0_;
	_tmp1_ = extents;
	_tmp2_ = _tmp1_.width;
	_tmp3_ = extents;
	_tmp4_ = _tmp3_.x_bearing;
	_tmp5_ = extents;
	_tmp6_ = _tmp5_.height;
	_tmp7_ = extents;
	_tmp8_ = _tmp7_.y_bearing;
	cairo_move_to (context, (x + (width * 0.5)) - ((_tmp2_ * 0.5) + _tmp4_), (y + (height * 0.5)) - ((_tmp6_ * 0.5) + _tmp8_));
	cairo_show_text (context, label);
}


/**
         * Helper method to draw grid lines with labels, all relative to reference_value.
         */
static void
pomodoro_stats_page_draw_guide_lines (cairo_t* context,
                                      gdouble reference_value,
                                      gdouble x,
                                      gdouble y,
                                      gdouble width,
                                      gdouble height,
                                      GdkRGBA* color)
{
	cairo_text_extents_t extents = {0};
	gint lines = 0;
	gdouble line_value = 0.0;
	gchar* line_label = NULL;
	gdouble _tmp0_;
	gchar* _tmp1_;
	gdouble line_x = 0.0;
	gdouble line_y = 0.0;
	gdouble unit = 0.0;
	gint _tmp2_;
	GdkRGBA _tmp3_;
	gdouble _tmp4_;
	GdkRGBA _tmp5_;
	gdouble _tmp6_;
	GdkRGBA _tmp7_;
	gdouble _tmp8_;
	GdkRGBA _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	g_return_if_fail (context != NULL);
	g_return_if_fail (color != NULL);
	if (reference_value <= 0.0) {
		return;
	}
	lines = MAX (1, (gint) floor (height / 135.0));
	line_value = 0.0;
	_tmp0_ = line_value;
	_tmp1_ = pomodoro_stats_page_format_value ((gint64) _tmp0_);
	line_label = _tmp1_;
	line_x = x;
	line_y = floor (y + height);
	_tmp2_ = lines;
	unit = exp2 (floor (log2 ((reference_value / ((gdouble) (_tmp2_ + 1))) / 3600.0))) * 3600.0;
	cairo_set_line_width (context, 1.0);
	_tmp3_ = *color;
	_tmp4_ = _tmp3_.red;
	_tmp5_ = *color;
	_tmp6_ = _tmp5_.green;
	_tmp7_ = *color;
	_tmp8_ = _tmp7_.blue;
	_tmp9_ = *color;
	_tmp10_ = _tmp9_.alpha;
	cairo_set_source_rgba (context, _tmp4_, _tmp6_, _tmp8_, _tmp10_ * 0.30);
	_tmp11_ = line_x;
	_tmp12_ = line_y;
	cairo_move_to (context, _tmp11_, _tmp12_ + 0.5);
	cairo_rel_line_to (context, width, 0.0);
	cairo_stroke (context);
	cairo_select_font_face (context, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL);
	{
		gint index = 0;
		index = 0;
		{
			gboolean _tmp13_ = FALSE;
			_tmp13_ = TRUE;
			while (TRUE) {
				gint _tmp15_;
				gint _tmp16_;
				gdouble _tmp17_;
				gdouble _tmp18_;
				gdouble _tmp19_;
				gchar* _tmp20_;
				gdouble _tmp21_;
				gdouble _tmp22_;
				gdouble _tmp23_;
				GdkRGBA _tmp24_;
				gdouble _tmp25_;
				GdkRGBA _tmp26_;
				gdouble _tmp27_;
				GdkRGBA _tmp28_;
				gdouble _tmp29_;
				GdkRGBA _tmp30_;
				gdouble _tmp31_;
				const gchar* _tmp32_;
				cairo_text_extents_t _tmp33_ = {0};
				gdouble _tmp34_;
				cairo_text_extents_t _tmp35_;
				gdouble _tmp36_;
				cairo_text_extents_t _tmp37_;
				gdouble _tmp38_;
				gdouble _tmp39_;
				cairo_text_extents_t _tmp40_;
				gdouble _tmp41_;
				cairo_text_extents_t _tmp42_;
				gdouble _tmp43_;
				GdkRGBA _tmp44_;
				gdouble _tmp45_;
				GdkRGBA _tmp46_;
				gdouble _tmp47_;
				GdkRGBA _tmp48_;
				gdouble _tmp49_;
				GdkRGBA _tmp50_;
				gdouble _tmp51_;
				const gchar* _tmp52_;
				if (!_tmp13_) {
					gint _tmp14_;
					_tmp14_ = index;
					index = _tmp14_ + 1;
				}
				_tmp13_ = FALSE;
				_tmp15_ = index;
				_tmp16_ = lines;
				if (!(_tmp15_ < _tmp16_)) {
					break;
				}
				_tmp17_ = line_value;
				_tmp18_ = unit;
				line_value = _tmp17_ + _tmp18_;
				_tmp19_ = line_value;
				_tmp20_ = pomodoro_stats_page_format_value ((gint64) _tmp19_);
				_g_free0 (line_label);
				line_label = _tmp20_;
				_tmp21_ = line_value;
				line_y = floor ((y + height) - ((height * _tmp21_) / reference_value));
				_tmp22_ = line_x;
				_tmp23_ = line_y;
				cairo_move_to (context, _tmp22_, _tmp23_ + 0.5);
				cairo_rel_line_to (context, width, 0.0);
				_tmp24_ = *color;
				_tmp25_ = _tmp24_.red;
				_tmp26_ = *color;
				_tmp27_ = _tmp26_.green;
				_tmp28_ = *color;
				_tmp29_ = _tmp28_.blue;
				_tmp30_ = *color;
				_tmp31_ = _tmp30_.alpha;
				cairo_set_source_rgba (context, _tmp25_, _tmp27_, _tmp29_, _tmp31_ * 0.10);
				cairo_stroke (context);
				_tmp32_ = line_label;
				cairo_text_extents (context, _tmp32_, &_tmp33_);
				extents = _tmp33_;
				_tmp34_ = line_x;
				_tmp35_ = extents;
				_tmp36_ = _tmp35_.width;
				_tmp37_ = extents;
				_tmp38_ = _tmp37_.x_bearing;
				_tmp39_ = line_y;
				_tmp40_ = extents;
				_tmp41_ = _tmp40_.height;
				_tmp42_ = extents;
				_tmp43_ = _tmp42_.y_bearing;
				cairo_move_to (context, ((_tmp34_ - _tmp36_) - _tmp38_) - POMODORO_STATS_PAGE_GUIDES_OFFSET, ((_tmp39_ - (_tmp41_ * 0.5)) - _tmp43_) - 1.0);
				_tmp44_ = *color;
				_tmp45_ = _tmp44_.red;
				_tmp46_ = *color;
				_tmp47_ = _tmp46_.green;
				_tmp48_ = *color;
				_tmp49_ = _tmp48_.blue;
				_tmp50_ = *color;
				_tmp51_ = _tmp50_.alpha;
				cairo_set_source_rgba (context, _tmp45_, _tmp47_, _tmp49_, _tmp51_ * 0.3);
				_tmp52_ = line_label;
				cairo_show_text (context, _tmp52_);
			}
		}
	}
	_g_free0 (line_label);
}


/**
         * Helper method to draw a single bar. It only draws paths without filling.
         */
static void
pomodoro_stats_page_draw_bar (cairo_t* context,
                              gdouble value,
                              gdouble x,
                              gdouble y,
                              gdouble width,
                              gdouble height)
{
	gdouble value_y = 0.0;
	gdouble value_height = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	g_return_if_fail (context != NULL);
	value_y = round ((y + height) - (value * height));
	_tmp0_ = value_y;
	value_height = (y + height) - _tmp0_;
	cairo_new_sub_path (context);
	_tmp1_ = value_height;
	if (_tmp1_ >= POMODORO_STATS_PAGE_BAR_BORDER_RADIUS) {
		gdouble _tmp2_;
		gdouble _tmp3_;
		cairo_move_to (context, x, y + height);
		_tmp2_ = value_y;
		cairo_arc (context, x + POMODORO_STATS_PAGE_BAR_BORDER_RADIUS, _tmp2_ + POMODORO_STATS_PAGE_BAR_BORDER_RADIUS, POMODORO_STATS_PAGE_BAR_BORDER_RADIUS, G_PI, 1.5 * G_PI);
		_tmp3_ = value_y;
		cairo_arc (context, (x + width) - POMODORO_STATS_PAGE_BAR_BORDER_RADIUS, _tmp3_ + POMODORO_STATS_PAGE_BAR_BORDER_RADIUS, POMODORO_STATS_PAGE_BAR_BORDER_RADIUS, (-0.5) * G_PI, 0.0);
		cairo_line_to (context, x + width, y + height);
	} else {
		gdouble _tmp4_;
		_tmp4_ = value_height;
		if (_tmp4_ != 0.0) {
			cairo_matrix_t matrix = {0};
			cairo_matrix_t _tmp5_ = {0};
			gdouble _tmp6_;
			gdouble _tmp7_;
			cairo_matrix_t _tmp8_;
			cairo_get_matrix (context, &_tmp5_);
			matrix = _tmp5_;
			_tmp6_ = value_y;
			_tmp7_ = value_height;
			cairo_translate (context, 0.0, _tmp6_ + _tmp7_);
			cairo_scale (context, 1.0, (value * height) / POMODORO_STATS_PAGE_BAR_BORDER_RADIUS);
			cairo_arc (context, x + POMODORO_STATS_PAGE_BAR_BORDER_RADIUS, 0.0, POMODORO_STATS_PAGE_BAR_BORDER_RADIUS, G_PI, 1.5 * G_PI);
			cairo_arc (context, (x + width) - POMODORO_STATS_PAGE_BAR_BORDER_RADIUS, 0.0, POMODORO_STATS_PAGE_BAR_BORDER_RADIUS, (-0.5) * G_PI, 0.0);
			_tmp8_ = matrix;
			cairo_set_matrix (context, &_tmp8_);
		}
	}
	cairo_close_path (context);
}


/**
         * Method for drawing values as bar chart.
         */
static void
pomodoro_stats_page_draw_bar_chart (cairo_t* context,
                                    gdouble* values,
                                    int values_length1,
                                    gdouble x,
                                    gdouble y,
                                    gdouble width,
                                    gdouble height)
{
	g_return_if_fail (context != NULL);
	if (values_length1 > 1) {
		gdouble segment_width = 0.0;
		gdouble bar_x = 0.0;
		gdouble bar_y = 0.0;
		gdouble bar_width = 0.0;
		gdouble bar_height = 0.0;
		gdouble _tmp0_;
		gdouble _tmp1_;
		gdouble _tmp2_;
		segment_width = width / ((gdouble) values_length1);
		bar_x = 0.0;
		bar_y = y;
		bar_width = 0.0;
		bar_height = height;
		_tmp0_ = segment_width;
		bar_width = MIN (floor (_tmp0_ * POMODORO_STATS_PAGE_BAR_RELATIVE_WIDTH), POMODORO_STATS_PAGE_BAR_MAX_WIDTH);
		_tmp1_ = segment_width;
		_tmp2_ = bar_width;
		bar_x = x + floor ((_tmp1_ - _tmp2_) / 2.0);
		{
			gint index = 0;
			index = 0;
			{
				gboolean _tmp3_ = FALSE;
				_tmp3_ = TRUE;
				while (TRUE) {
					gint _tmp5_;
					gint _tmp6_;
					gdouble _tmp7_;
					gdouble _tmp8_;
					gdouble _tmp9_;
					gint _tmp10_;
					gdouble _tmp11_;
					gdouble _tmp12_;
					gdouble _tmp13_;
					if (!_tmp3_) {
						gint _tmp4_;
						_tmp4_ = index;
						index = _tmp4_ + 1;
					}
					_tmp3_ = FALSE;
					_tmp5_ = index;
					if (!(_tmp5_ < values_length1)) {
						break;
					}
					_tmp6_ = index;
					_tmp7_ = values[_tmp6_];
					_tmp8_ = bar_x;
					_tmp9_ = segment_width;
					_tmp10_ = index;
					_tmp11_ = bar_y;
					_tmp12_ = bar_width;
					_tmp13_ = bar_height;
					pomodoro_stats_page_draw_bar (context, _tmp7_, _tmp8_ + (_tmp9_ * ((gdouble) _tmp10_)), _tmp11_, _tmp12_, _tmp13_);
				}
			}
		}
	}
}


/**
         * Method for drawing values as smooth line chart.
         */
static void
pomodoro_stats_page_draw_line_chart (cairo_t* context,
                                     gdouble* values,
                                     int values_length1,
                                     gdouble x,
                                     gdouble y,
                                     gdouble width,
                                     gdouble height)
{
	g_return_if_fail (context != NULL);
	if (values_length1 > 1) {
		gdouble segment_width = 0.0;
		gdouble x0 = 0.0;
		gdouble _tmp0_;
		gdouble y0 = 0.0;
		gdouble x1 = 0.0;
		gdouble y1 = 0.0;
		gdouble x2 = 0.0;
		gdouble y2 = 0.0;
		gdouble x3 = 0.0;
		gdouble y3 = 0.0;
		gdouble x6 = 0.0;
		gdouble y6 = 0.0;
		gdouble slope0 = 0.0;
		gdouble slope3 = 0.0;
		gdouble _tmp1_;
		gdouble _tmp2_;
		segment_width = width / ((gdouble) (values_length1 - 1));
		_tmp0_ = segment_width;
		x0 = x - _tmp0_;
		y0 = y + height;
		x1 = 0.0;
		y1 = 0.0;
		x2 = 0.0;
		y2 = 0.0;
		x3 = 0.0;
		y3 = 0.0;
		x6 = 0.0;
		y6 = 0.0;
		slope0 = 0.0;
		slope3 = 0.0;
		cairo_new_path (context);
		_tmp1_ = x0;
		_tmp2_ = y0;
		cairo_move_to (context, _tmp1_, _tmp2_);
		{
			gint index = 0;
			index = -1;
			{
				gboolean _tmp3_ = FALSE;
				_tmp3_ = TRUE;
				while (TRUE) {
					gint _tmp5_;
					gdouble _tmp6_;
					gdouble _tmp7_;
					gdouble _tmp8_ = 0.0;
					gint _tmp9_;
					gdouble _tmp12_;
					gdouble _tmp13_;
					gdouble _tmp14_ = 0.0;
					gint _tmp15_;
					gdouble _tmp18_;
					gdouble _tmp19_;
					gdouble _tmp20_;
					gdouble _tmp21_;
					gdouble _tmp22_;
					gdouble _tmp23_;
					gdouble _tmp24_;
					gdouble _tmp25_;
					gdouble _tmp26_;
					gdouble _tmp27_;
					gdouble _tmp28_;
					gdouble _tmp29_;
					gdouble _tmp30_;
					gdouble _tmp31_;
					gdouble _tmp32_;
					gdouble _tmp33_;
					gdouble _tmp34_;
					gdouble _tmp35_;
					gdouble _tmp36_;
					gdouble _tmp37_;
					gdouble _tmp38_;
					gdouble _tmp39_;
					gdouble _tmp40_;
					gdouble _tmp41_;
					gdouble _tmp42_;
					gdouble _tmp43_;
					gdouble _tmp44_;
					if (!_tmp3_) {
						gint _tmp4_;
						_tmp4_ = index;
						index = _tmp4_ + 1;
					}
					_tmp3_ = FALSE;
					_tmp5_ = index;
					if (!(_tmp5_ < values_length1)) {
						break;
					}
					_tmp6_ = x0;
					_tmp7_ = segment_width;
					x3 = _tmp6_ + _tmp7_;
					_tmp9_ = index;
					if ((_tmp9_ + 1) < values_length1) {
						gint _tmp10_;
						gdouble _tmp11_;
						_tmp10_ = index;
						_tmp11_ = values[_tmp10_ + 1];
						_tmp8_ = _tmp11_;
					} else {
						_tmp8_ = 0.0;
					}
					y3 = y + (height * (1.0 - _tmp8_));
					_tmp12_ = x3;
					_tmp13_ = segment_width;
					x6 = _tmp12_ + _tmp13_;
					_tmp15_ = index;
					if ((_tmp15_ + 2) < values_length1) {
						gint _tmp16_;
						gdouble _tmp17_;
						_tmp16_ = index;
						_tmp17_ = values[_tmp16_ + 2];
						_tmp14_ = _tmp17_;
					} else {
						_tmp14_ = 0.0;
					}
					y6 = y + (height * (1.0 - _tmp14_));
					_tmp18_ = y6;
					_tmp19_ = y0;
					_tmp20_ = x6;
					_tmp21_ = x0;
					slope3 = (_tmp18_ - _tmp19_) / (_tmp20_ - _tmp21_);
					_tmp22_ = x0;
					_tmp23_ = x3;
					_tmp24_ = x0;
					x1 = _tmp22_ + ((_tmp23_ - _tmp24_) * 0.5);
					_tmp25_ = y0;
					_tmp26_ = slope0;
					_tmp27_ = x1;
					_tmp28_ = x0;
					y1 = _tmp25_ + (_tmp26_ * (_tmp27_ - _tmp28_));
					_tmp29_ = x3;
					_tmp30_ = x3;
					_tmp31_ = x0;
					x2 = _tmp29_ - ((_tmp30_ - _tmp31_) * 0.5);
					_tmp32_ = y3;
					_tmp33_ = slope3;
					_tmp34_ = x2;
					_tmp35_ = x3;
					y2 = _tmp32_ + (_tmp33_ * (_tmp34_ - _tmp35_));
					_tmp36_ = x1;
					_tmp37_ = y1;
					_tmp38_ = x2;
					_tmp39_ = y2;
					_tmp40_ = x3;
					_tmp41_ = y3;
					cairo_curve_to (context, _tmp36_, _tmp37_, _tmp38_, _tmp39_, _tmp40_, _tmp41_);
					_tmp42_ = x3;
					x0 = _tmp42_;
					_tmp43_ = y3;
					y0 = _tmp43_;
					_tmp44_ = slope3;
					slope0 = _tmp44_;
				}
			}
		}
	}
}


/**
         * Method for drawing values as linear chart.
         */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static gpointer
_pomodoro_stats_page_data_dup0 (gpointer self)
{
	return self ? pomodoro_stats_page_data_dup (self) : NULL;
}


static gboolean
pomodoro_stats_page_on_timeline_chart_draw (PomodoroStatsPage* self,
                                            GtkWidget* widget,
                                            cairo_t* context)
{
	gboolean result = FALSE;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	gdouble width = 0.0;
	gdouble height = 0.0;
	gdouble chart_x = 0.0;
	gdouble chart_y = 0.0;
	gdouble chart_width = 0.0;
	gdouble _tmp2_;
	gdouble chart_height = 0.0;
	gdouble _tmp3_;
	gint days_count = 0;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	gdouble* pomodoro_values = NULL;
	gint _tmp7_;
	gdouble* _tmp8_;
	gint pomodoro_values_length1;
	gint _pomodoro_values_size_;
	gdouble* total_values = NULL;
	gint _tmp9_;
	gdouble* _tmp10_;
	gint total_values_length1;
	gint _total_values_size_;
	gdouble reference_value = 0.0;
	guint64 _tmp11_;
	PomodoroStatsPageDrawChartFunc draw_chart_func = NULL;
	void* draw_chart_func_target;
	GDestroyNotify draw_chart_func_target_destroy_notify;
	gdouble label_x = 0.0;
	gdouble _tmp12_;
	gdouble label_y = 0.0;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble label_width = 0.0;
	gdouble _tmp15_;
	gint _tmp16_;
	gdouble label_height = 0.0;
	gint _tmp17_;
	cairo_text_extents_t label_extents = {0};
	GdkRGBA theme_fg_color = {0};
	GtkStyleContext* _tmp18_;
	GdkRGBA _tmp19_ = {0};
	GdkRGBA theme_bg_color = {0};
	GdkRGBA theme_selected_bg_color = {0};
	GtkStyleContext* _tmp20_;
	GdkRGBA _tmp21_ = {0};
	GtkStyleContext* _tmp22_;
	GdkRGBA _tmp23_ = {0};
	GdkRGBA _tmp24_;
	gdouble _tmp25_;
	GdkRGBA _tmp26_;
	gdouble _tmp27_;
	GdkRGBA _tmp28_;
	gdouble _tmp29_;
	GdkRGBA _tmp30_;
	gdouble _tmp31_;
	gdouble _tmp96_;
	gdouble _tmp97_;
	gdouble _tmp98_;
	gdouble _tmp99_;
	gdouble _tmp100_;
	GdkRGBA _tmp101_;
	gdouble _tmp102_;
	gdouble _tmp103_;
	gdouble _tmp104_;
	GdkRGBA _tmp105_;
	gdouble _tmp106_;
	GdkRGBA _tmp107_;
	gdouble _tmp108_;
	GdkRGBA _tmp109_;
	gdouble _tmp110_;
	GdkRGBA _tmp111_;
	gdouble _tmp112_;
	GdkRGBA _tmp113_;
	gdouble _tmp114_;
	GdkRGBA _tmp115_;
	gdouble _tmp116_;
	GdkRGBA _tmp117_;
	gdouble _tmp118_;
	PomodoroStatsPageDrawChartFunc _tmp119_;
	void* _tmp119__target;
	gdouble* _tmp120_;
	gint _tmp120__length1;
	gdouble _tmp121_;
	gdouble _tmp122_;
	gdouble _tmp123_;
	gdouble _tmp124_;
	GdkRGBA _tmp125_;
	gdouble _tmp126_;
	GdkRGBA _tmp127_;
	gdouble _tmp128_;
	GdkRGBA _tmp129_;
	gdouble _tmp130_;
	GdkRGBA _tmp131_;
	gdouble _tmp132_;
	PomodoroStatsPageDrawChartFunc _tmp133_;
	void* _tmp133__target;
	gdouble* _tmp134_;
	gint _tmp134__length1;
	gdouble _tmp135_;
	gdouble _tmp136_;
	gdouble _tmp137_;
	gdouble _tmp138_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp0_ = gtk_widget_get_style_context (widget);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	style_context = _tmp1_;
	width = (gdouble) gtk_widget_get_allocated_width (widget);
	height = (gdouble) gtk_widget_get_allocated_height (widget);
	chart_x = POMODORO_STATS_PAGE_GUIDES_WIDTH + POMODORO_STATS_PAGE_CHART_PADDING;
	chart_y = 0.0;
	_tmp2_ = width;
	chart_width = _tmp2_ - (2.0 * (POMODORO_STATS_PAGE_GUIDES_WIDTH + POMODORO_STATS_PAGE_CHART_PADDING));
	_tmp3_ = height;
	chart_height = (_tmp3_ - POMODORO_STATS_PAGE_LABEL_OFFSET) - POMODORO_STATS_PAGE_LABEL_HEIGHT;
	_tmp4_ = self->priv->_date_end;
	_tmp5_ = pomodoro_stats_page_get_date (self);
	_tmp6_ = _tmp5_;
	days_count = (gint) (g_date_time_difference (_tmp4_, _tmp6_) / G_TIME_SPAN_DAY);
	_tmp7_ = days_count;
	_tmp8_ = g_new0 (gdouble, _tmp7_);
	pomodoro_values = _tmp8_;
	pomodoro_values_length1 = _tmp7_;
	_pomodoro_values_size_ = pomodoro_values_length1;
	_tmp9_ = days_count;
	_tmp10_ = g_new0 (gdouble, _tmp9_);
	total_values = _tmp10_;
	total_values_length1 = _tmp9_;
	_total_values_size_ = total_values_length1;
	_tmp11_ = self->daily_reference_value;
	reference_value = MAX ((gdouble) _tmp11_, 3600.0);
	draw_chart_func = (PomodoroStatsPageDrawChartFunc) pomodoro_stats_page_draw_bar_chart;
	draw_chart_func_target = NULL;
	draw_chart_func_target_destroy_notify = NULL;
	_tmp12_ = chart_x;
	label_x = _tmp12_;
	_tmp13_ = chart_y;
	_tmp14_ = chart_height;
	label_y = _tmp13_ + _tmp14_;
	_tmp15_ = chart_width;
	_tmp16_ = days_count;
	label_width = _tmp15_ / ((gdouble) _tmp16_);
	label_height = POMODORO_STATS_PAGE_LABEL_HEIGHT;
	_tmp17_ = days_count;
	if (_tmp17_ > 7) {
		(draw_chart_func_target_destroy_notify == NULL) ? NULL : (draw_chart_func_target_destroy_notify (draw_chart_func_target), NULL);
		draw_chart_func = NULL;
		draw_chart_func_target = NULL;
		draw_chart_func_target_destroy_notify = NULL;
		draw_chart_func = (PomodoroStatsPageDrawChartFunc) pomodoro_stats_page_draw_line_chart;
		draw_chart_func_target = NULL;
		draw_chart_func_target_destroy_notify = NULL;
	}
	_tmp18_ = style_context;
	gtk_style_context_get_color (_tmp18_, gtk_widget_get_state_flags (widget), &_tmp19_);
	theme_fg_color = _tmp19_;
	_tmp20_ = style_context;
	gtk_style_context_lookup_color (_tmp20_, "theme_selected_bg_color", &_tmp21_);
	theme_selected_bg_color = _tmp21_;
	_tmp22_ = style_context;
	gtk_style_context_lookup_color (_tmp22_, "theme_bg_color", &_tmp23_);
	theme_bg_color = _tmp23_;
	cairo_select_font_face (context, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL);
	cairo_set_font_size (context, 13.0);
	_tmp24_ = theme_fg_color;
	_tmp25_ = _tmp24_.red;
	_tmp26_ = theme_fg_color;
	_tmp27_ = _tmp26_.green;
	_tmp28_ = theme_fg_color;
	_tmp29_ = _tmp28_.blue;
	_tmp30_ = theme_fg_color;
	_tmp31_ = _tmp30_.alpha;
	cairo_set_source_rgba (context, _tmp25_, _tmp27_, _tmp29_, _tmp31_);
	{
		gint index = 0;
		index = 0;
		{
			gboolean _tmp32_ = FALSE;
			_tmp32_ = TRUE;
			while (TRUE) {
				gint _tmp34_;
				gint _tmp35_;
				GDateTime* date = NULL;
				GDateTime* _tmp36_;
				GDateTime* _tmp37_;
				gint _tmp38_;
				GDateTime* _tmp39_;
				PomodoroStatsPageData* day = NULL;
				GHashTable* _tmp40_;
				GDateTime* _tmp41_;
				gchar* _tmp42_;
				gchar* _tmp43_;
				gconstpointer _tmp44_;
				PomodoroStatsPageData* _tmp45_;
				PomodoroStatsPageData* _tmp46_;
				PomodoroStatsPageData* _tmp47_;
				gboolean _tmp68_ = FALSE;
				gint _tmp69_;
				if (!_tmp32_) {
					gint _tmp33_;
					_tmp33_ = index;
					index = _tmp33_ + 1;
				}
				_tmp32_ = FALSE;
				_tmp34_ = index;
				_tmp35_ = days_count;
				if (!(_tmp34_ < _tmp35_)) {
					break;
				}
				_tmp36_ = pomodoro_stats_page_get_date (self);
				_tmp37_ = _tmp36_;
				_tmp38_ = index;
				_tmp39_ = g_date_time_add_days (_tmp37_, _tmp38_);
				date = _tmp39_;
				_tmp40_ = self->priv->days;
				_tmp41_ = date;
				_tmp42_ = g_date_time_format (_tmp41_, "%Y-%m-%d");
				_tmp43_ = _tmp42_;
				_tmp44_ = g_hash_table_lookup (_tmp40_, _tmp43_);
				_tmp45_ = _pomodoro_stats_page_data_dup0 ((PomodoroStatsPageData*) _tmp44_);
				_tmp46_ = _tmp45_;
				_g_free0 (_tmp43_);
				day = _tmp46_;
				_tmp47_ = day;
				if (_tmp47_ != NULL) {
					gdouble* _tmp48_;
					gint _tmp48__length1;
					gint _tmp49_;
					PomodoroStatsPageData* _tmp50_;
					gint64 _tmp51_;
					gdouble _tmp52_;
					gdouble _tmp53_;
					gdouble* _tmp54_;
					gint _tmp54__length1;
					gint _tmp55_;
					PomodoroStatsPageData* _tmp56_;
					gint64 _tmp57_;
					PomodoroStatsPageData* _tmp58_;
					gint64 _tmp59_;
					gdouble _tmp60_;
					gdouble _tmp61_;
					_tmp48_ = pomodoro_values;
					_tmp48__length1 = pomodoro_values_length1;
					_tmp49_ = index;
					_tmp50_ = day;
					_tmp51_ = (*_tmp50_).pomodoro_elapsed;
					_tmp52_ = reference_value;
					_tmp48_[_tmp49_] = _tmp51_ / _tmp52_;
					_tmp53_ = _tmp48_[_tmp49_];
					_tmp54_ = total_values;
					_tmp54__length1 = total_values_length1;
					_tmp55_ = index;
					_tmp56_ = day;
					_tmp57_ = (*_tmp56_).pomodoro_elapsed;
					_tmp58_ = day;
					_tmp59_ = (*_tmp58_).break_elapsed;
					_tmp60_ = reference_value;
					_tmp54_[_tmp55_] = (_tmp57_ + _tmp59_) / _tmp60_;
					_tmp61_ = _tmp54_[_tmp55_];
				} else {
					gdouble* _tmp62_;
					gint _tmp62__length1;
					gint _tmp63_;
					gdouble _tmp64_;
					gdouble* _tmp65_;
					gint _tmp65__length1;
					gint _tmp66_;
					gdouble _tmp67_;
					_tmp62_ = pomodoro_values;
					_tmp62__length1 = pomodoro_values_length1;
					_tmp63_ = index;
					_tmp62_[_tmp63_] = 0.0;
					_tmp64_ = _tmp62_[_tmp63_];
					_tmp65_ = total_values;
					_tmp65__length1 = total_values_length1;
					_tmp66_ = index;
					_tmp65_[_tmp66_] = 0.0;
					_tmp67_ = _tmp65_[_tmp66_];
				}
				_tmp69_ = days_count;
				if (_tmp69_ <= 7) {
					_tmp68_ = TRUE;
				} else {
					GDateTime* _tmp70_;
					_tmp70_ = date;
					_tmp68_ = g_date_time_get_day_of_week (_tmp70_) == 1;
				}
				if (_tmp68_) {
					gchar* _tmp71_ = NULL;
					gint _tmp72_;
					gchar* label_text = NULL;
					gchar* _tmp77_;
					gdouble _tmp78_;
					gdouble _tmp79_;
					gint _tmp80_;
					const gchar* _tmp81_;
					cairo_text_extents_t _tmp82_ = {0};
					gdouble _tmp83_;
					gdouble _tmp84_;
					cairo_text_extents_t _tmp85_;
					gdouble _tmp86_;
					cairo_text_extents_t _tmp87_;
					gdouble _tmp88_;
					gdouble _tmp89_;
					gdouble _tmp90_;
					cairo_text_extents_t _tmp91_;
					gdouble _tmp92_;
					cairo_text_extents_t _tmp93_;
					gdouble _tmp94_;
					const gchar* _tmp95_;
					_tmp72_ = days_count;
					if (_tmp72_ <= 7) {
						GDateTime* _tmp73_;
						gchar* _tmp74_;
						_tmp73_ = date;
						_tmp74_ = pomodoro_stats_page_format_day_of_week (_tmp73_);
						_g_free0 (_tmp71_);
						_tmp71_ = _tmp74_;
					} else {
						GDateTime* _tmp75_;
						gchar* _tmp76_;
						_tmp75_ = date;
						_tmp76_ = pomodoro_stats_page_format_day_of_month (_tmp75_);
						_g_free0 (_tmp71_);
						_tmp71_ = _tmp76_;
					}
					_tmp77_ = g_strdup (_tmp71_);
					label_text = _tmp77_;
					_tmp78_ = chart_x;
					_tmp79_ = label_width;
					_tmp80_ = index;
					label_x = _tmp78_ + (_tmp79_ * ((gdouble) _tmp80_));
					_tmp81_ = label_text;
					cairo_text_extents (context, _tmp81_, &_tmp82_);
					label_extents = _tmp82_;
					_tmp83_ = label_x;
					_tmp84_ = label_width;
					_tmp85_ = label_extents;
					_tmp86_ = _tmp85_.width;
					_tmp87_ = label_extents;
					_tmp88_ = _tmp87_.x_bearing;
					_tmp89_ = label_y;
					_tmp90_ = label_height;
					_tmp91_ = label_extents;
					_tmp92_ = _tmp91_.height;
					_tmp93_ = label_extents;
					_tmp94_ = _tmp93_.y_bearing;
					cairo_move_to (context, (_tmp83_ + ((_tmp84_ - _tmp86_) * 0.5)) - _tmp88_, (_tmp89_ + ((_tmp90_ - _tmp92_) * 0.5)) - _tmp94_);
					_tmp95_ = label_text;
					cairo_show_text (context, _tmp95_);
					_g_free0 (label_text);
					_g_free0 (_tmp71_);
				}
				_pomodoro_stats_page_data_free0 (day);
				_g_date_time_unref0 (date);
			}
		}
	}
	_tmp96_ = reference_value;
	_tmp97_ = chart_x;
	_tmp98_ = chart_y;
	_tmp99_ = chart_width;
	_tmp100_ = chart_height;
	_tmp101_ = theme_fg_color;
	pomodoro_stats_page_draw_guide_lines (context, _tmp96_, _tmp97_ - POMODORO_STATS_PAGE_CHART_PADDING, _tmp98_, _tmp99_ + (2.0 * POMODORO_STATS_PAGE_CHART_PADDING), _tmp100_, &_tmp101_);
	_tmp102_ = chart_y;
	_tmp103_ = width;
	_tmp104_ = chart_height;
	cairo_rectangle (context, 0.0, _tmp102_, _tmp103_, _tmp104_);
	cairo_clip (context);
	_tmp105_ = theme_selected_bg_color;
	_tmp106_ = _tmp105_.red;
	_tmp107_ = theme_bg_color;
	_tmp108_ = _tmp107_.red;
	_tmp109_ = theme_selected_bg_color;
	_tmp110_ = _tmp109_.green;
	_tmp111_ = theme_bg_color;
	_tmp112_ = _tmp111_.green;
	_tmp113_ = theme_selected_bg_color;
	_tmp114_ = _tmp113_.blue;
	_tmp115_ = theme_bg_color;
	_tmp116_ = _tmp115_.blue;
	_tmp117_ = theme_selected_bg_color;
	_tmp118_ = _tmp117_.alpha;
	cairo_set_source_rgba (context, (_tmp106_ * 0.8) + (_tmp108_ * 0.2), (_tmp110_ * 0.8) + (_tmp112_ * 0.2), (_tmp114_ * 0.8) + (_tmp116_ * 0.2), _tmp118_ * 0.6);
	_tmp119_ = draw_chart_func;
	_tmp119__target = draw_chart_func_target;
	_tmp120_ = total_values;
	_tmp120__length1 = total_values_length1;
	_tmp121_ = chart_x;
	_tmp122_ = chart_y;
	_tmp123_ = chart_width;
	_tmp124_ = chart_height;
	_tmp119_ (context, _tmp120_, _tmp120__length1, _tmp121_, _tmp122_, _tmp123_, _tmp124_, _tmp119__target);
	cairo_fill (context);
	_tmp125_ = theme_selected_bg_color;
	_tmp126_ = _tmp125_.red;
	_tmp127_ = theme_selected_bg_color;
	_tmp128_ = _tmp127_.green;
	_tmp129_ = theme_selected_bg_color;
	_tmp130_ = _tmp129_.blue;
	_tmp131_ = theme_selected_bg_color;
	_tmp132_ = _tmp131_.alpha;
	cairo_set_source_rgba (context, _tmp126_, _tmp128_, _tmp130_, _tmp132_);
	_tmp133_ = draw_chart_func;
	_tmp133__target = draw_chart_func_target;
	_tmp134_ = pomodoro_values;
	_tmp134__length1 = pomodoro_values_length1;
	_tmp135_ = chart_x;
	_tmp136_ = chart_y;
	_tmp137_ = chart_width;
	_tmp138_ = chart_height;
	_tmp133_ (context, _tmp134_, _tmp134__length1, _tmp135_, _tmp136_, _tmp137_, _tmp138_, _tmp133__target);
	cairo_fill (context);
	result = FALSE;
	(draw_chart_func_target_destroy_notify == NULL) ? NULL : (draw_chart_func_target_destroy_notify (draw_chart_func_target), NULL);
	draw_chart_func = NULL;
	draw_chart_func_target = NULL;
	draw_chart_func_target_destroy_notify = NULL;
	total_values = (g_free (total_values), NULL);
	pomodoro_values = (g_free (pomodoro_values), NULL);
	_g_object_unref0 (style_context);
	return result;
}


static gboolean
_pomodoro_stats_page_on_timeline_chart_draw_gtk_widget_draw (GtkWidget* _sender,
                                                             cairo_t* cr,
                                                             gpointer self)
{
	gboolean result;
	result = pomodoro_stats_page_on_timeline_chart_draw ((PomodoroStatsPage*) self, _sender, cr);
	return result;
}


static Block15Data*
block15_data_ref (Block15Data* _data15_)
{
	g_atomic_int_inc (&_data15_->_ref_count_);
	return _data15_;
}


static void
block15_data_unref (void * _userdata_)
{
	Block15Data* _data15_;
	_data15_ = (Block15Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data15_->_ref_count_)) {
		PomodoroStatsPage* self;
		self = _data15_->self;
		_g_object_unref0 (self);
		g_slice_free (Block15Data, _data15_);
	}
}


static void
__lambda9_ (Block15Data* _data15_,
            const gchar* date_string,
            PomodoroStatsPageData* data)
{
	PomodoroStatsPage* self;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	gint64 _tmp3_;
	self = _data15_->self;
	g_return_if_fail (date_string != NULL);
	_tmp0_ = _data15_->totals.pomodoro_elapsed;
	_tmp1_ = (*data).pomodoro_elapsed;
	_data15_->totals.pomodoro_elapsed = _tmp0_ + _tmp1_;
	_tmp2_ = _data15_->totals.break_elapsed;
	_tmp3_ = (*data).break_elapsed;
	_data15_->totals.break_elapsed = _tmp2_ + _tmp3_;
}


static void
___lambda9__gh_func (gconstpointer key,
                     gconstpointer value,
                     gpointer self)
{
	__lambda9_ (self, (const gchar*) key, (PomodoroStatsPageData*) value);
}


static gboolean
pomodoro_stats_page_on_totals_chart_draw (PomodoroStatsPage* self,
                                          GtkWidget* widget,
                                          cairo_t* context)
{
	gboolean result = FALSE;
	Block15Data* _data15_;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	gdouble width = 0.0;
	gdouble height = 0.0;
	gdouble chart_x = 0.0;
	gdouble chart_y = 0.0;
	gdouble chart_width = 0.0;
	gdouble chart_height = 0.0;
	gdouble reference_value = 0.0;
	guint64 _tmp2_;
	gdouble bar_x = 0.0;
	gdouble bar_y = 0.0;
	gdouble bar_width = 0.0;
	gdouble bar_height = 0.0;
	gdouble bar_spacing = 0.0;
	gdouble label_x = 0.0;
	gdouble _tmp3_;
	gdouble label_y = 0.0;
	gdouble label_width = 0.0;
	gdouble label_height = 0.0;
	GdkRGBA theme_selected_bg_color = {0};
	GdkRGBA theme_border_color = {0};
	GdkRGBA theme_fg_color = {0};
	GdkRGBA _tmp4_ = {0};
	GdkRGBA _tmp5_ = {0};
	GdkRGBA _tmp6_ = {0};
	GHashTable* _tmp7_;
	GdkRGBA _tmp8_;
	GdkRGBA _tmp9_;
	gdouble _tmp10_;
	GdkRGBA _tmp11_;
	gdouble _tmp12_;
	GdkRGBA _tmp13_;
	gdouble _tmp14_;
	GdkRGBA _tmp15_;
	gdouble _tmp16_;
	PomodoroStatsPageData _tmp17_;
	gint64 _tmp18_;
	gdouble _tmp19_;
	GdkRGBA _tmp20_;
	gdouble _tmp21_;
	GdkRGBA _tmp22_;
	gdouble _tmp23_;
	GdkRGBA _tmp24_;
	gdouble _tmp25_;
	GdkRGBA _tmp26_;
	gdouble _tmp27_;
	gdouble _tmp28_;
	gdouble _tmp29_;
	gdouble _tmp30_;
	gdouble _tmp31_;
	PomodoroStatsPageData _tmp32_;
	gint64 _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gdouble _tmp36_;
	gdouble _tmp37_;
	GdkRGBA _tmp38_;
	gdouble _tmp39_;
	GdkRGBA _tmp40_;
	gdouble _tmp41_;
	GdkRGBA _tmp42_;
	gdouble _tmp43_;
	GdkRGBA _tmp44_;
	gdouble _tmp45_;
	PomodoroStatsPageData _tmp46_;
	gint64 _tmp47_;
	gdouble _tmp48_;
	GdkRGBA _tmp49_;
	gdouble _tmp50_;
	GdkRGBA _tmp51_;
	gdouble _tmp52_;
	GdkRGBA _tmp53_;
	gdouble _tmp54_;
	GdkRGBA _tmp55_;
	gdouble _tmp56_;
	gdouble _tmp57_;
	gdouble _tmp58_;
	gdouble _tmp59_;
	gdouble _tmp60_;
	PomodoroStatsPageData _tmp61_;
	gint64 _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	gdouble _tmp65_;
	gdouble _tmp66_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (context != NULL, FALSE);
	_data15_ = g_slice_new0 (Block15Data);
	_data15_->_ref_count_ = 1;
	_data15_->self = g_object_ref (self);
	_tmp0_ = gtk_widget_get_style_context (widget);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	style_context = _tmp1_;
	width = (gdouble) gtk_widget_get_allocated_width (widget);
	height = (gdouble) gtk_widget_get_allocated_height (widget);
	chart_x = POMODORO_STATS_PAGE_GUIDES_WIDTH + POMODORO_STATS_PAGE_CHART_PADDING;
	chart_y = 0.0;
	chart_width = width - (2.0 * (POMODORO_STATS_PAGE_GUIDES_WIDTH + POMODORO_STATS_PAGE_CHART_PADDING));
	chart_height = (height - POMODORO_STATS_PAGE_LABEL_OFFSET) - (2.0 * POMODORO_STATS_PAGE_LABEL_HEIGHT);
	_tmp2_ = self->reference_value;
	reference_value = MAX ((gdouble) _tmp2_, 3600.0);
	bar_x = 0.0;
	bar_y = chart_y;
	bar_width = POMODORO_STATS_PAGE_BAR_MAX_WIDTH;
	bar_height = chart_height;
	bar_spacing = 20.0;
	_tmp3_ = bar_x;
	label_x = _tmp3_;
	label_y = bar_y + bar_height;
	label_width = bar_width;
	label_height = POMODORO_STATS_PAGE_LABEL_HEIGHT;
	gtk_style_context_get_color (style_context, gtk_widget_get_state_flags (widget), &_tmp4_);
	theme_fg_color = _tmp4_;
	gtk_style_context_lookup_color (style_context, "theme_selected_bg_color", &_tmp5_);
	theme_selected_bg_color = _tmp5_;
	gtk_style_context_lookup_color (style_context, "borders", &_tmp6_);
	theme_border_color = _tmp6_;
	memset (&_data15_->totals, 0, sizeof (PomodoroStatsPageData));
	_tmp7_ = self->priv->days;
	g_hash_table_foreach (_tmp7_, ___lambda9__gh_func, _data15_);
	_tmp8_ = theme_fg_color;
	pomodoro_stats_page_draw_guide_lines (context, reference_value, chart_x - POMODORO_STATS_PAGE_CHART_PADDING, chart_y, chart_width + (2.0 * POMODORO_STATS_PAGE_CHART_PADDING), chart_height, &_tmp8_);
	bar_x = floor (((chart_x + (chart_width / 2.0)) - (bar_spacing / 2.0)) - bar_width);
	_tmp9_ = theme_selected_bg_color;
	_tmp10_ = _tmp9_.red;
	_tmp11_ = theme_selected_bg_color;
	_tmp12_ = _tmp11_.green;
	_tmp13_ = theme_selected_bg_color;
	_tmp14_ = _tmp13_.blue;
	_tmp15_ = theme_selected_bg_color;
	_tmp16_ = _tmp15_.alpha;
	cairo_set_source_rgba (context, _tmp10_, _tmp12_, _tmp14_, _tmp16_);
	_tmp17_ = _data15_->totals;
	_tmp18_ = _tmp17_.pomodoro_elapsed;
	_tmp19_ = bar_x;
	pomodoro_stats_page_draw_bar (context, _tmp18_ / reference_value, _tmp19_, bar_y, bar_width, bar_height);
	cairo_fill (context);
	cairo_select_font_face (context, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
	cairo_set_font_size (context, 14.0);
	_tmp20_ = theme_fg_color;
	_tmp21_ = _tmp20_.red;
	_tmp22_ = theme_fg_color;
	_tmp23_ = _tmp22_.green;
	_tmp24_ = theme_fg_color;
	_tmp25_ = _tmp24_.blue;
	_tmp26_ = theme_fg_color;
	_tmp27_ = _tmp26_.alpha;
	cairo_set_source_rgba (context, _tmp21_, _tmp23_, _tmp25_, _tmp27_);
	_tmp28_ = bar_x;
	label_x = _tmp28_;
	label_y = (bar_y + bar_height) + POMODORO_STATS_PAGE_LABEL_OFFSET;
	_tmp29_ = label_x;
	_tmp30_ = label_y;
	pomodoro_stats_page_draw_label (context, _ ("Pomodoro"), _tmp29_, _tmp30_, label_width, label_height);
	_tmp31_ = label_y;
	label_y = _tmp31_ + label_height;
	cairo_select_font_face (context, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL);
	_tmp32_ = _data15_->totals;
	_tmp33_ = _tmp32_.pomodoro_elapsed;
	_tmp34_ = pomodoro_stats_page_format_value (_tmp33_);
	_tmp35_ = _tmp34_;
	_tmp36_ = label_x;
	_tmp37_ = label_y;
	pomodoro_stats_page_draw_label (context, _tmp35_, _tmp36_, _tmp37_, label_width, label_height);
	_g_free0 (_tmp35_);
	bar_x = floor ((chart_x + (chart_width / 2.0)) + (bar_spacing / 2.0));
	_tmp38_ = theme_selected_bg_color;
	_tmp39_ = _tmp38_.red;
	_tmp40_ = theme_selected_bg_color;
	_tmp41_ = _tmp40_.green;
	_tmp42_ = theme_selected_bg_color;
	_tmp43_ = _tmp42_.blue;
	_tmp44_ = theme_selected_bg_color;
	_tmp45_ = _tmp44_.alpha;
	cairo_set_source_rgba (context, _tmp39_, _tmp41_, _tmp43_, _tmp45_);
	_tmp46_ = _data15_->totals;
	_tmp47_ = _tmp46_.break_elapsed;
	_tmp48_ = bar_x;
	pomodoro_stats_page_draw_bar (context, _tmp47_ / reference_value, _tmp48_, bar_y, bar_width, bar_height);
	cairo_fill (context);
	cairo_select_font_face (context, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
	cairo_set_font_size (context, 14.0);
	_tmp49_ = theme_fg_color;
	_tmp50_ = _tmp49_.red;
	_tmp51_ = theme_fg_color;
	_tmp52_ = _tmp51_.green;
	_tmp53_ = theme_fg_color;
	_tmp54_ = _tmp53_.blue;
	_tmp55_ = theme_fg_color;
	_tmp56_ = _tmp55_.alpha;
	cairo_set_source_rgba (context, _tmp50_, _tmp52_, _tmp54_, _tmp56_);
	_tmp57_ = bar_x;
	label_x = _tmp57_;
	label_y = (bar_y + bar_height) + POMODORO_STATS_PAGE_LABEL_OFFSET;
	_tmp58_ = label_x;
	_tmp59_ = label_y;
	pomodoro_stats_page_draw_label (context, _ ("Break"), _tmp58_, _tmp59_, label_width, label_height);
	_tmp60_ = label_y;
	label_y = _tmp60_ + label_height;
	cairo_select_font_face (context, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL);
	_tmp61_ = _data15_->totals;
	_tmp62_ = _tmp61_.break_elapsed;
	_tmp63_ = pomodoro_stats_page_format_value (_tmp62_);
	_tmp64_ = _tmp63_;
	_tmp65_ = label_x;
	_tmp66_ = label_y;
	pomodoro_stats_page_draw_label (context, _tmp64_, _tmp65_, _tmp66_, label_width, label_height);
	_g_free0 (_tmp64_);
	result = FALSE;
	_g_object_unref0 (style_context);
	block15_data_unref (_data15_);
	_data15_ = NULL;
	return result;
}


static gboolean
_pomodoro_stats_page_on_totals_chart_draw_gtk_widget_draw (GtkWidget* _sender,
                                                           cairo_t* cr,
                                                           gpointer self)
{
	gboolean result;
	result = pomodoro_stats_page_on_totals_chart_draw ((PomodoroStatsPage*) self, _sender, cr);
	return result;
}


static void
__lambda12_ (PomodoroStatsPage* self,
             GObject* obj,
             GAsyncResult* res)
{
	GtkDrawingArea* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	GtkDrawingArea* _tmp6_;
	GtkSpinner* _tmp7_;
	GtkDrawingArea* _tmp8_;
	GtkDrawingArea* _tmp10_;
	g_return_if_fail (res != NULL);
	pomodoro_stats_page_fetch_finish (self, res);
	_tmp0_ = self->timeline_chart;
	_tmp1_ = self->priv->_date_end;
	_tmp2_ = pomodoro_stats_page_get_date (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_date_time_add_weeks (_tmp3_, 1);
	_tmp5_ = _tmp4_;
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, g_date_time_compare (_tmp1_, _tmp5_) >= 0);
	_g_date_time_unref0 (_tmp5_);
	_tmp6_ = self->totals_chart;
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, TRUE);
	_tmp7_ = self->spinner;
	g_object_set (_tmp7_, "active", FALSE, NULL);
	_tmp8_ = self->timeline_chart;
	if (gtk_widget_get_mapped ((GtkWidget*) _tmp8_)) {
		GtkDrawingArea* _tmp9_;
		_tmp9_ = self->timeline_chart;
		gtk_widget_queue_draw ((GtkWidget*) _tmp9_);
	}
	_tmp10_ = self->totals_chart;
	if (gtk_widget_get_mapped ((GtkWidget*) _tmp10_)) {
		GtkDrawingArea* _tmp11_;
		_tmp11_ = self->totals_chart;
		gtk_widget_queue_draw ((GtkWidget*) _tmp11_);
	}
}


static void
___lambda12__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda12_ ((PomodoroStatsPage*) self, source_object, res);
	g_object_unref (self);
}


void
pomodoro_stats_page_update (PomodoroStatsPage* self)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GtkDrawingArea* _tmp2_;
	GtkDrawingArea* _tmp3_;
	GtkSpinner* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = pomodoro_stats_page_get_next_date (self);
	_tmp1_ = _tmp0_;
	pomodoro_stats_page_set_date_end (self, _tmp1_);
	_g_date_time_unref0 (_tmp1_);
	_tmp2_ = self->timeline_chart;
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
	_tmp3_ = self->totals_chart;
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
	_tmp4_ = self->spinner;
	g_object_set (_tmp4_, "active", TRUE, NULL);
	pomodoro_stats_page_fetch (self, ___lambda12__gasync_ready_callback, g_object_ref (self));
}


static void
pomodoro_stats_page_fetch_data_free (gpointer _data)
{
	PomodoroStatsPageFetchData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (PomodoroStatsPageFetchData, _data_);
}


static void
pomodoro_stats_page_fetch_async_ready_wrapper (GObject *source_object,
                                               GAsyncResult *res,
                                               void *user_data)
{
	PomodoroStatsPageFetchData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}


void
pomodoro_stats_page_fetch (PomodoroStatsPage* self,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	PomodoroStatsPageFetchData* _data_;
	PomodoroStatsPage* _tmp0_;
	_data_ = g_slice_new0 (PomodoroStatsPageFetchData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, pomodoro_stats_page_fetch_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, pomodoro_stats_page_fetch_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	pomodoro_stats_page_fetch_co (_data_);
}


void
pomodoro_stats_page_fetch_finish (PomodoroStatsPage* self,
                                  GAsyncResult* _res_)
{
	PomodoroStatsPageFetchData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}


static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
	g_atomic_int_inc (&_data16_->_ref_count_);
	return _data16_;
}


static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
		PomodoroStatsPage* self;
		self = _data16_->self;
		_g_object_unref0 (self);
		g_slice_free (Block16Data, _data16_);
	}
}


static void
pomodoro_stats_page_fetch_ready (GObject* source_object,
                                 GAsyncResult* _res_,
                                 gpointer _user_data_)
{
	PomodoroStatsPageFetchData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	_data_->_task_complete_ = TRUE;
	pomodoro_stats_page_fetch_co (_data_);
}


static Block17Data*
block17_data_ref (Block17Data* _data17_)
{
	g_atomic_int_inc (&_data17_->_ref_count_);
	return _data17_;
}


static void
block17_data_unref (void * _userdata_)
{
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
		PomodoroStatsPage* self;
		self = _data17_->_data16_->self;
		_g_object_unref0 (_data17_->group);
		block16_data_unref (_data17_->_data16_);
		_data17_->_data16_ = NULL;
		g_slice_free (Block17Data, _data17_);
	}
}


static void
____lambda11_ (Block17Data* _data17_,
               GObject* obj,
               GAsyncResult* res)
{
	Block16Data* _data16_;
	PomodoroStatsPage* self;
	GError * _inner_error_ = NULL;
	_data16_ = _data17_->_data16_;
	self = _data16_->self;
	g_return_if_fail (res != NULL);
	{
		gom_resource_group_fetch_finish (_data17_->group, res, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch24_g_error;
		}
		{
			gint index = 0;
			index = 0;
			{
				gboolean _tmp0_ = FALSE;
				_tmp0_ = TRUE;
				while (TRUE) {
					gint _tmp2_;
					guint _tmp3_;
					guint _tmp4_;
					PomodoroAggregatedEntry* aggregated_entry = NULL;
					gint _tmp5_;
					GomResource* _tmp6_;
					PomodoroAggregatedEntry* _tmp7_;
					PomodoroStatsPageData* day = NULL;
					GHashTable* _tmp8_;
					PomodoroAggregatedEntry* _tmp9_;
					const gchar* _tmp10_;
					const gchar* _tmp11_;
					gconstpointer _tmp12_;
					PomodoroStatsPageData* _tmp13_;
					PomodoroStatsPageData* _tmp14_;
					PomodoroAggregatedEntry* _tmp17_;
					const gchar* _tmp18_;
					const gchar* _tmp19_;
					const gchar* _tmp20_;
					GQuark _tmp22_ = 0U;
					static GQuark _tmp21_label0 = 0;
					static GQuark _tmp21_label1 = 0;
					static GQuark _tmp21_label2 = 0;
					static GQuark _tmp21_label3 = 0;
					GHashTable* _tmp35_;
					PomodoroAggregatedEntry* _tmp36_;
					const gchar* _tmp37_;
					const gchar* _tmp38_;
					gchar* _tmp39_;
					PomodoroStatsPageData* _tmp40_;
					PomodoroStatsPageData* _tmp41_;
					if (!_tmp0_) {
						gint _tmp1_;
						_tmp1_ = index;
						index = _tmp1_ + 1;
					}
					_tmp0_ = FALSE;
					_tmp2_ = index;
					_tmp3_ = gom_resource_group_get_count (_data17_->group);
					_tmp4_ = _tmp3_;
					if (!(((guint) _tmp2_) < _tmp4_)) {
						break;
					}
					_tmp5_ = index;
					_tmp6_ = gom_resource_group_get_index (_data17_->group, (guint) _tmp5_);
					_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, POMODORO_TYPE_AGGREGATED_ENTRY) ? ((PomodoroAggregatedEntry*) _tmp6_) : NULL);
					aggregated_entry = _tmp7_;
					_tmp8_ = self->priv->days;
					_tmp9_ = aggregated_entry;
					_tmp10_ = pomodoro_aggregated_entry_get_date_string (_tmp9_);
					_tmp11_ = _tmp10_;
					_tmp12_ = g_hash_table_lookup (_tmp8_, _tmp11_);
					_tmp13_ = _pomodoro_stats_page_data_dup0 ((PomodoroStatsPageData*) _tmp12_);
					day = _tmp13_;
					_tmp14_ = day;
					if (_tmp14_ == NULL) {
						PomodoroStatsPageData _tmp15_ = {0};
						PomodoroStatsPageData* _tmp16_;
						memset (&_tmp15_, 0, sizeof (PomodoroStatsPageData));
						_tmp16_ = _pomodoro_stats_page_data_dup0 (&_tmp15_);
						_pomodoro_stats_page_data_free0 (day);
						day = _tmp16_;
					}
					_tmp17_ = aggregated_entry;
					_tmp18_ = pomodoro_aggregated_entry_get_state_name (_tmp17_);
					_tmp19_ = _tmp18_;
					_tmp20_ = _tmp19_;
					_tmp22_ = (NULL == _tmp20_) ? 0 : g_quark_from_string (_tmp20_);
					if (_tmp22_ == ((0 != _tmp21_label0) ? _tmp21_label0 : (_tmp21_label0 = g_quark_from_static_string ("pomodoro")))) {
						switch (0) {
							default:
							{
								PomodoroStatsPageData* _tmp23_;
								PomodoroStatsPageData* _tmp24_;
								gint64 _tmp25_;
								PomodoroAggregatedEntry* _tmp26_;
								gint64 _tmp27_;
								gint64 _tmp28_;
								_tmp23_ = day;
								_tmp24_ = day;
								_tmp25_ = (*_tmp24_).pomodoro_elapsed;
								_tmp26_ = aggregated_entry;
								_tmp27_ = pomodoro_aggregated_entry_get_elapsed (_tmp26_);
								_tmp28_ = _tmp27_;
								(*_tmp24_).pomodoro_elapsed = _tmp25_ + _tmp28_;
								break;
							}
						}
					} else if (((_tmp22_ == ((0 != _tmp21_label1) ? _tmp21_label1 : (_tmp21_label1 = g_quark_from_static_string ("break")))) || (_tmp22_ == ((0 != _tmp21_label2) ? _tmp21_label2 : (_tmp21_label2 = g_quark_from_static_string ("short-break"))))) || (_tmp22_ == ((0 != _tmp21_label3) ? _tmp21_label3 : (_tmp21_label3 = g_quark_from_static_string ("long-break"))))) {
						switch (0) {
							default:
							{
								PomodoroStatsPageData* _tmp29_;
								PomodoroStatsPageData* _tmp30_;
								gint64 _tmp31_;
								PomodoroAggregatedEntry* _tmp32_;
								gint64 _tmp33_;
								gint64 _tmp34_;
								_tmp29_ = day;
								_tmp30_ = day;
								_tmp31_ = (*_tmp30_).break_elapsed;
								_tmp32_ = aggregated_entry;
								_tmp33_ = pomodoro_aggregated_entry_get_elapsed (_tmp32_);
								_tmp34_ = _tmp33_;
								(*_tmp30_).break_elapsed = _tmp31_ + _tmp34_;
								break;
							}
						}
					} else {
						switch (0) {
							default:
							{
								break;
							}
						}
					}
					_tmp35_ = self->priv->days;
					_tmp36_ = aggregated_entry;
					_tmp37_ = pomodoro_aggregated_entry_get_date_string (_tmp36_);
					_tmp38_ = _tmp37_;
					_tmp39_ = g_strdup (_tmp38_);
					_tmp40_ = day;
					_tmp41_ = _pomodoro_stats_page_data_dup0 (_tmp40_);
					g_hash_table_insert (_tmp35_, _tmp39_, _tmp41_);
					_pomodoro_stats_page_data_free0 (day);
					_g_object_unref0 (aggregated_entry);
				}
			}
		}
	}
	goto __finally24;
	__catch24_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp42_;
		const gchar* _tmp43_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		_tmp42_ = _error_;
		_tmp43_ = _tmp42_->message;
		g_critical ("stats-page.vala:702: %s", _tmp43_);
		_g_error_free0 (_error_);
	}
	__finally24:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void
_____lambda11__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
	____lambda11_ (self, source_object, res);
	block17_data_unref (self);
}


static void
__lambda10_ (Block16Data* _data16_,
             GObject* obj,
             GAsyncResult* res)
{
	PomodoroStatsPage* self;
	GError * _inner_error_ = NULL;
	self = _data16_->self;
	g_return_if_fail (res != NULL);
	{
		Block17Data* _data17_;
		GomRepository* _tmp0_;
		GomResourceGroup* _tmp1_;
		guint _tmp2_;
		guint _tmp3_;
		_data17_ = g_slice_new0 (Block17Data);
		_data17_->_ref_count_ = 1;
		_data17_->_data16_ = block16_data_ref (_data16_);
		_tmp0_ = self->repository;
		_tmp1_ = gom_repository_find_finish (_tmp0_, res, &_inner_error_);
		_data17_->group = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			block17_data_unref (_data17_);
			_data17_ = NULL;
			goto __catch23_g_error;
		}
		_tmp2_ = gom_resource_group_get_count (_data17_->group);
		_tmp3_ = _tmp2_;
		if (_tmp3_ > ((guint) 0)) {
			guint _tmp4_;
			guint _tmp5_;
			_tmp4_ = gom_resource_group_get_count (_data17_->group);
			_tmp5_ = _tmp4_;
			gom_resource_group_fetch_async (_data17_->group, (guint) 0, _tmp5_, _____lambda11__gasync_ready_callback, block17_data_ref (_data17_));
		}
		block17_data_unref (_data17_);
		_data17_ = NULL;
	}
	goto __finally23;
	__catch23_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = _error_;
		_tmp7_ = _tmp6_->message;
		g_critical ("stats-page.vala:708: %s", _tmp7_);
		_g_error_free0 (_error_);
	}
	__finally23:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	self->reference_value = _data16_->reference_value;
	self->daily_reference_value = (guint64) _data16_->daily_reference_value;
	pomodoro_stats_page_fetch_co (_data16_->_async_data_);
}


static void
___lambda10__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda10_ (self, source_object, res);
	block16_data_unref (self);
}


static gboolean
pomodoro_stats_page_fetch_co (PomodoroStatsPageFetchData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data16_ = g_slice_new0 (Block16Data);
	_data_->_data16_->_ref_count_ = 1;
	_data_->_data16_->self = g_object_ref (_data_->self);
	_data_->_data16_->_async_data_ = _data_;
	_data_->_tmp0_ = _data_->self->priv->days;
	g_hash_table_remove_all (_data_->_tmp0_);
	_data_->_tmp1_ = pomodoro_stats_page_get_date (_data_->self);
	_data_->_tmp2_ = _data_->_tmp1_;
	_data_->_tmp3_ = g_date_time_format (_data_->_tmp2_, POMODORO_AGGREGATED_ENTRY_DATE_FORMAT);
	_data_->date_start = _data_->_tmp3_;
	_data_->_tmp4_ = _data_->self->priv->_date_end;
	_data_->_tmp5_ = g_date_time_format (_data_->_tmp4_, POMODORO_AGGREGATED_ENTRY_DATE_FORMAT);
	_data_->date_end = _data_->_tmp5_;
	memset (&_data_->_tmp6_, 0, sizeof (GValue));
	g_value_init (&_data_->_tmp6_, G_TYPE_STRING);
	g_value_set_string (&_data_->_tmp6_, _data_->date_start);
	_data_->_tmp7_ = gom_filter_new_gte (POMODORO_TYPE_AGGREGATED_ENTRY, "date-string", &_data_->_tmp6_);
	g_object_ref_sink (_data_->_tmp7_);
	_data_->_tmp8_ = _data_->_tmp7_;
	memset (&_data_->_tmp9_, 0, sizeof (GValue));
	g_value_init (&_data_->_tmp9_, G_TYPE_STRING);
	g_value_set_string (&_data_->_tmp9_, _data_->date_end);
	_data_->_tmp10_ = gom_filter_new_lt (POMODORO_TYPE_AGGREGATED_ENTRY, "date-string", &_data_->_tmp9_);
	g_object_ref_sink (_data_->_tmp10_);
	_data_->_tmp11_ = _data_->_tmp10_;
	_data_->_tmp12_ = gom_filter_new_and (_data_->_tmp8_, _data_->_tmp11_);
	g_object_ref_sink (_data_->_tmp12_);
	_data_->_tmp13_ = _data_->_tmp12_;
	_g_object_unref0 (_data_->_tmp11_);
	G_IS_VALUE (&_data_->_tmp9_) ? (g_value_unset (&_data_->_tmp9_), NULL) : NULL;
	_g_object_unref0 (_data_->_tmp8_);
	G_IS_VALUE (&_data_->_tmp6_) ? (g_value_unset (&_data_->_tmp6_), NULL) : NULL;
	_data_->filter = _data_->_tmp13_;
	_data_->_state_ = 1;
	pomodoro_stats_page_get_reference_value (_data_->self, pomodoro_stats_page_fetch_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_data16_->reference_value = pomodoro_stats_page_get_reference_value_finish (_data_->self, _data_->_res_);
	_data_->_state_ = 2;
	pomodoro_aggregated_entry_get_baseline_daily_elapsed (pomodoro_stats_page_fetch_ready, _data_);
	return FALSE;
	_state_2:
	_data_->_data16_->daily_reference_value = pomodoro_aggregated_entry_get_baseline_daily_elapsed_finish (_data_->_res_);
	_data_->_tmp14_ = _data_->self->repository;
	gom_repository_find_async (_data_->_tmp14_, POMODORO_TYPE_AGGREGATED_ENTRY, _data_->filter, ___lambda10__gasync_ready_callback, block16_data_ref (_data_->_data16_));
	_data_->_state_ = 3;
	return FALSE;
	_state_3:
	;
	_g_object_unref0 (_data_->filter);
	_g_free0 (_data_->date_end);
	_g_free0 (_data_->date_start);
	block16_data_unref (_data_->_data16_);
	_data_->_data16_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (_data_->_task_complete_ != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static gchar*
pomodoro_stats_page_real_format_datetime (PomodoroStatsPage* self,
                                          GDateTime* date)
{
	gchar* result = NULL;
	g_return_val_if_fail (date != NULL, NULL);
	g_assert_not_reached ();
	return result;
}


gchar*
pomodoro_stats_page_format_datetime (PomodoroStatsPage* self,
                                     GDateTime* date)
{
	g_return_val_if_fail (self != NULL, NULL);
	return POMODORO_STATS_PAGE_GET_CLASS (self)->format_datetime (self, date);
}


static GDateTime*
pomodoro_stats_page_real_get_previous_date (PomodoroStatsPage* self)
{
	GDateTime* result = NULL;
	g_assert_not_reached ();
	return result;
}


GDateTime*
pomodoro_stats_page_get_previous_date (PomodoroStatsPage* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return POMODORO_STATS_PAGE_GET_CLASS (self)->get_previous_date (self);
}


static GDateTime*
pomodoro_stats_page_real_get_next_date (PomodoroStatsPage* self)
{
	GDateTime* result = NULL;
	g_assert_not_reached ();
	return result;
}


GDateTime*
pomodoro_stats_page_get_next_date (PomodoroStatsPage* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return POMODORO_STATS_PAGE_GET_CLASS (self)->get_next_date (self);
}


static void
pomodoro_stats_page_real_get_reference_value_data_free (gpointer _data)
{
	PomodoroStatsPageGetReferenceValueData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (PomodoroStatsPageGetReferenceValueData, _data_);
}


static void
pomodoro_stats_page_real_get_reference_value_async_ready_wrapper (GObject *source_object,
                                                                  GAsyncResult *res,
                                                                  void *user_data)
{
	PomodoroStatsPageGetReferenceValueData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}


static void
pomodoro_stats_page_real_get_reference_value (PomodoroStatsPage* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	PomodoroStatsPageGetReferenceValueData* _data_;
	PomodoroStatsPage* _tmp0_;
	_data_ = g_slice_new0 (PomodoroStatsPageGetReferenceValueData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, pomodoro_stats_page_real_get_reference_value_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, pomodoro_stats_page_real_get_reference_value_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	pomodoro_stats_page_real_get_reference_value_co (_data_);
}


static guint64
pomodoro_stats_page_real_get_reference_value_finish (PomodoroStatsPage* self,
                                                     GAsyncResult* _res_)
{
	guint64 result;
	PomodoroStatsPageGetReferenceValueData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}


static gboolean
pomodoro_stats_page_real_get_reference_value_co (PomodoroStatsPageGetReferenceValueData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->result = (guint64) 0;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (_data_->_task_complete_ != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


void
pomodoro_stats_page_get_reference_value (PomodoroStatsPage* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	POMODORO_STATS_PAGE_GET_CLASS (self)->get_reference_value (self, _callback_, _user_data_);
}


guint64
pomodoro_stats_page_get_reference_value_finish (PomodoroStatsPage* self,
                                                GAsyncResult* _res_)
{
	return POMODORO_STATS_PAGE_GET_CLASS (self)->get_reference_value_finish (self, _res_);
}


PomodoroStatsPage*
pomodoro_stats_page_construct (GType object_type)
{
	PomodoroStatsPage * self = NULL;
	self = (PomodoroStatsPage*) g_object_new (object_type, NULL);
	return self;
}


GDateTime*
pomodoro_stats_page_get_date (PomodoroStatsPage* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->_date;
	result = _tmp0_;
	return result;
}


static gpointer
_g_date_time_ref0 (gpointer self)
{
	return self ? g_date_time_ref (self) : NULL;
}


void
pomodoro_stats_page_set_date (PomodoroStatsPage* self,
                              GDateTime* value)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_date_time_ref0 (value);
	_g_date_time_unref0 (self->_date);
	self->_date = _tmp0_;
	_tmp1_ = self->_date;
	_tmp2_ = pomodoro_stats_page_format_datetime (self, _tmp1_);
	_tmp3_ = _tmp2_;
	pomodoro_stats_page_set_title (self, _tmp3_);
	_g_free0 (_tmp3_);
	g_object_notify_by_pspec ((GObject *) self, pomodoro_stats_page_properties[POMODORO_STATS_PAGE_DATE_PROPERTY]);
}


GDateTime*
pomodoro_stats_page_get_date_end (PomodoroStatsPage* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_date_end;
	result = _tmp0_;
	return result;
}


void
pomodoro_stats_page_set_date_end (PomodoroStatsPage* self,
                                  GDateTime* value)
{
	g_return_if_fail (self != NULL);
	if (pomodoro_stats_page_get_date_end (self) != value) {
		GDateTime* _tmp0_;
		_tmp0_ = _g_date_time_ref0 (value);
		_g_date_time_unref0 (self->priv->_date_end);
		self->priv->_date_end = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, pomodoro_stats_page_properties[POMODORO_STATS_PAGE_DATE_END_PROPERTY]);
	}
}


const gchar*
pomodoro_stats_page_get_title (PomodoroStatsPage* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_title;
	result = _tmp0_;
	return result;
}


void
pomodoro_stats_page_set_title (PomodoroStatsPage* self,
                               const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, pomodoro_stats_page_get_title (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_title);
		self->priv->_title = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, pomodoro_stats_page_properties[POMODORO_STATS_PAGE_TITLE_PROPERTY]);
	}
}


static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}


static void
_pomodoro_stats_page_data_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (pomodoro_stats_page_data_free (var), NULL));
}


static GObject *
pomodoro_stats_page_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PomodoroStatsPage * self;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	parent_class = G_OBJECT_CLASS (pomodoro_stats_page_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_STATS_PAGE, PomodoroStatsPage);
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _pomodoro_stats_page_data_free0_);
	_g_hash_table_unref0 (self->priv->days);
	self->priv->days = _tmp2_;
	return obj;
}


static PomodoroStatsPageData*
pomodoro_stats_page_data_dup (const PomodoroStatsPageData* self)
{
	PomodoroStatsPageData* dup;
	dup = g_new0 (PomodoroStatsPageData, 1);
	memcpy (dup, self, sizeof (PomodoroStatsPageData));
	return dup;
}


static void
pomodoro_stats_page_data_free (PomodoroStatsPageData* self)
{
	g_free (self);
}


static GType
pomodoro_stats_page_data_get_type (void)
{
	static volatile gsize pomodoro_stats_page_data_type_id__volatile = 0;
	if (g_once_init_enter (&pomodoro_stats_page_data_type_id__volatile)) {
		GType pomodoro_stats_page_data_type_id;
		pomodoro_stats_page_data_type_id = g_boxed_type_register_static ("PomodoroStatsPageData", (GBoxedCopyFunc) pomodoro_stats_page_data_dup, (GBoxedFreeFunc) pomodoro_stats_page_data_free);
		g_once_init_leave (&pomodoro_stats_page_data_type_id__volatile, pomodoro_stats_page_data_type_id);
	}
	return pomodoro_stats_page_data_type_id__volatile;
}


static void
pomodoro_stats_page_class_init (PomodoroStatsPageClass * klass)
{
	gint PomodoroStatsPage_private_offset;
	pomodoro_stats_page_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PomodoroStatsPagePrivate));
	((PomodoroStatsPageClass *) klass)->format_datetime = (gchar* (*) (PomodoroStatsPage *, GDateTime*)) pomodoro_stats_page_real_format_datetime;
	((PomodoroStatsPageClass *) klass)->get_previous_date = (GDateTime* (*) (PomodoroStatsPage *)) pomodoro_stats_page_real_get_previous_date;
	((PomodoroStatsPageClass *) klass)->get_next_date = (GDateTime* (*) (PomodoroStatsPage *)) pomodoro_stats_page_real_get_next_date;
	((PomodoroStatsPageClass *) klass)->get_reference_value = (void (*) (PomodoroStatsPage *, GAsyncReadyCallback, gpointer)) pomodoro_stats_page_real_get_reference_value;
	((PomodoroStatsPageClass *) klass)->get_reference_value_finish = (guint64 (*) (PomodoroStatsPage *, GAsyncResult*)) pomodoro_stats_page_real_get_reference_value_finish;
	G_OBJECT_CLASS (klass)->get_property = _vala_pomodoro_stats_page_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_pomodoro_stats_page_set_property;
	G_OBJECT_CLASS (klass)->constructor = pomodoro_stats_page_constructor;
	G_OBJECT_CLASS (klass)->finalize = pomodoro_stats_page_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_STATS_PAGE_DATE_PROPERTY, pomodoro_stats_page_properties[POMODORO_STATS_PAGE_DATE_PROPERTY] = g_param_spec_boxed ("date", "date", "date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_STATS_PAGE_DATE_END_PROPERTY, pomodoro_stats_page_properties[POMODORO_STATS_PAGE_DATE_END_PROPERTY] = g_param_spec_boxed ("date-end", "date-end", "date-end", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_STATS_PAGE_TITLE_PROPERTY, pomodoro_stats_page_properties[POMODORO_STATS_PAGE_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	PomodoroStatsPage_private_offset = g_type_class_get_instance_private_offset (klass);
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/pomodoro/stats-page.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "spinner", FALSE, G_STRUCT_OFFSET (PomodoroStatsPage, spinner));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "timeline_chart", FALSE, G_STRUCT_OFFSET (PomodoroStatsPage, timeline_chart));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "totals_chart", FALSE, G_STRUCT_OFFSET (PomodoroStatsPage, totals_chart));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_timeline_chart_draw", G_CALLBACK(_pomodoro_stats_page_on_timeline_chart_draw_gtk_widget_draw));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_totals_chart_draw", G_CALLBACK(_pomodoro_stats_page_on_totals_chart_draw_gtk_widget_draw));
}


static void
pomodoro_stats_page_gtk_buildable_interface_init (GtkBuildableIface * iface)
{
	pomodoro_stats_page_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
}


static void
pomodoro_stats_page_instance_init (PomodoroStatsPage * self)
{
	self->priv = POMODORO_STATS_PAGE_GET_PRIVATE (self);
	gtk_widget_init_template (GTK_WIDGET (self));
}


static void
pomodoro_stats_page_finalize (GObject * obj)
{
	PomodoroStatsPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_STATS_PAGE, PomodoroStatsPage);
	_g_date_time_unref0 (self->priv->_date_end);
	_g_free0 (self->priv->_title);
	_g_object_unref0 (self->spinner);
	_g_object_unref0 (self->timeline_chart);
	_g_object_unref0 (self->totals_chart);
	_g_date_time_unref0 (self->_date);
	_g_object_unref0 (self->repository);
	_g_hash_table_unref0 (self->priv->days);
	G_OBJECT_CLASS (pomodoro_stats_page_parent_class)->finalize (obj);
}


GType
pomodoro_stats_page_get_type (void)
{
	static volatile gsize pomodoro_stats_page_type_id__volatile = 0;
	if (g_once_init_enter (&pomodoro_stats_page_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PomodoroStatsPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_stats_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroStatsPage), 0, (GInstanceInitFunc) pomodoro_stats_page_instance_init, NULL };
		static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) pomodoro_stats_page_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType pomodoro_stats_page_type_id;
		pomodoro_stats_page_type_id = g_type_register_static (gtk_box_get_type (), "PomodoroStatsPage", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_type_add_interface_static (pomodoro_stats_page_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
		g_once_init_leave (&pomodoro_stats_page_type_id__volatile, pomodoro_stats_page_type_id);
	}
	return pomodoro_stats_page_type_id__volatile;
}


static void
_vala_pomodoro_stats_page_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	PomodoroStatsPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_STATS_PAGE, PomodoroStatsPage);
	switch (property_id) {
		case POMODORO_STATS_PAGE_DATE_PROPERTY:
		g_value_set_boxed (value, pomodoro_stats_page_get_date (self));
		break;
		case POMODORO_STATS_PAGE_DATE_END_PROPERTY:
		g_value_set_boxed (value, pomodoro_stats_page_get_date_end (self));
		break;
		case POMODORO_STATS_PAGE_TITLE_PROPERTY:
		g_value_set_string (value, pomodoro_stats_page_get_title (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_pomodoro_stats_page_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	PomodoroStatsPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_STATS_PAGE, PomodoroStatsPage);
	switch (property_id) {
		case POMODORO_STATS_PAGE_DATE_PROPERTY:
		pomodoro_stats_page_set_date (self, g_value_get_boxed (value));
		break;
		case POMODORO_STATS_PAGE_DATE_END_PROPERTY:
		pomodoro_stats_page_set_date_end (self, g_value_get_boxed (value));
		break;
		case POMODORO_STATS_PAGE_TITLE_PROPERTY:
		pomodoro_stats_page_set_title (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



